#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define MAXSTRINGLEN 256

char * CalculateBarcode2of5_int(unsigned long BarcodeNumber, char * PrintString)
{
   /* Function to calculate the Barcodes
      Return the result string.
      Note: There could be some Printing information already stored in the PrintString!
   */
   char BarcodeNumberStr[34];
   char * NumberStartStr = BarcodeNumberStr + 1;
   int Pos, i = 0;

   /* Convert Numer into a string, that's easier to handle the calculation */
   ultoa(BarcodeNumber, NumberStartStr, 10);

   /* length of the Barcode must be dividable by 2 */
   if (strlen(NumberStartStr) % 2)
   {
      *BarcodeNumberStr = '0';                  /* Add Zero at first position */
      NumberStartStr --;
   }

   /* Ok, now lets get the font selections sequence. We will use the
      secondary font so teh primary will be unchanged.
      The pointsize of the font will be 20 points
      Also add the start byte of the font '#'
   */
   strcat(PrintString, ")10Q)s1p20vsb13001T#");

   /* Now convert the Barcode and add the convert bytes to the print string
      Note: the print string was initialized with 0x0!
   */
   Pos = (int) strlen(PrintString);
   while(i < (int) strlen(NumberStartStr))
   {
      /* The 48 has to bu subtracted, because ASCII Zero is 48 and we calcualte
         the number out of teh sting format
      */
      PrintString[Pos++] = (unsigned char) ((NumberStartStr[i] - '0') * 10 + NumberStartStr[i + 1] - '0' + 40);
      PrintString[Pos] = 0x0;
      i += 2;
   }

   /* finally we must add the stop sequence and return to the primary font*/
   strcat(PrintString, "$");

   return(PrintString);
}

char * GetPos(float Position, char * BufferStr, char EndStr)
{
   /* The offset Position has to be multiplied with 28.34 to get
      the 1/720 inch resolution
   */
   sprintf(BufferStr, "&a%u%c", (unsigned int) (Position * 28.34), EndStr);
   return(BufferStr);
}

char * CalculatePosBarcode2of5_int(unsigned long BarcodeNumber, char * PrintString, float xPos, float yPos)
{
   char BufferStr[20];

   strcat(PrintString, "&fS");   /* Store actual printing Position in printer */
   strcat(PrintString, GetPos(xPos, BufferStr, 'H'));           /* Add &a###H */
   strcat(PrintString, GetPos(yPos, BufferStr, 'V'));           /* Add &a###V */
   CalculateBarcode2of5_int(BarcodeNumber, PrintString);
   strcat(PrintString, "&f1S");  /* recall printing Position in printer */
   return(PrintString);
}

void main(int argc,char *argv[])
{
   /* Programm for printing barcode 2of5 interleaved.
      Functionality:  The user will enter the barcode number
   */
   unsigned long BarcodeNumber;
   char PrintString[MAXSTRINGLEN];

   *PrintString = 0x0;
   printf("\n\nPlease enter the barcode number: ");
   scanf("%lu", &BarcodeNumber);
   printf("Print string: %s\n\n", CalculateBarcode2of5_int(BarcodeNumber, PrintString));

   {  /* second example
         Is just teh same as the first one, in addition you will enter a
         special printing position. The printing of the barcode will not
         change the printing font and the actual position!
      */
      float xPos, yPos;

      printf("Position in mm from the left paper margin: ");
      scanf("%f", &xPos);
      printf("Position in mm from the upper paper margin: ");
      scanf("%f", &yPos);

      /* This is an additional reset sequence. We have to add it for this
         example, because we have to set the printers physical top print position
         to zero! See rechnical reference manual for further explanations.
      */
      strcpy(PrintString, "[E&lE]");
      printf("Print string: %s\n\n", CalculatePosBarcode2of5_int(BarcodeNumber, PrintString, xPos, yPos));
   }
   exit(0);
}
